<?php

const ORDER_SAVE_FOLDER = './orders/';

function gen_uuid() {
    return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
        // 32 bits for "time_low"
        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ),

        // 16 bits for "time_mid"
        mt_rand( 0, 0xffff ),

        // 16 bits for "time_hi_and_version",
        // four most significant bits holds version number 4
        mt_rand( 0, 0x0fff ) | 0x4000,

        // 16 bits, 8 bits for "clk_seq_hi_res",
        // 8 bits for "clk_seq_low",
        // two most significant bits holds zero and one for variant DCE1.1
        mt_rand( 0, 0x3fff ) | 0x8000,

        // 48 bits for "node"
        mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff )
    );
}

function order_to_xml( $data, $xmlNode ) {
    foreach( $data as $key => $value ) {
        if( is_array($value) ) {
            @list($name, $count, $summ) = $value;
            $subnode = $xmlNode->addChild('item');
            order_to_xml(compact('name', 'count', 'summ'), $subnode);
        } else {
            $xmlNode->addChild($key, htmlentities($value));
        }
     }
}

$orderJSON = isset($_POST['order']) ? $_POST['order'] : null;
$order = @json_decode($orderJSON, true);

if (empty($order['items']) || empty($order['summ']) || !is_array($order['items'])) {
	echo '{"result":false}';
	return;
}

$xmlData = new SimpleXMLElement('<?xml version="1.0" encoding="utf-8"?><order></order>');

order_to_xml($order['items'], $xmlData->addChild('items'));
order_to_xml(['total_summ' => $order['summ']], $xmlData);

$result = $xmlData->asXML(ORDER_SAVE_FOLDER . '/order_' . gen_uuid() . '.xml');
echo json_encode(compact('result'));